;**********************************************************************
;                        					       *
                  
;**********************************************************************
;                                                                     *
;    NOM:                      JEUFFRAULT/BERRADA                     *
;    Date:                     Avril 2003                             *
;    Version:                  1.0                                    *
;    Circuit:				Emetteur
;    Auteur:
;                                                                     *
;**********************************************************************
;                                                                     *
;    Fichier requis: P16F870.inc                                       *
;                                                                     *
;                                                                     *
;                                                                     *
;**********************************************************************
;                                                                     *
;    Notes:                                                           *
;                                                                     *
;                                                                     *
;                                                                     *
;                                                                     *
;**********************************************************************


	LIST      p=16F870            ; Dfinition de processeur
	#include <p16F870.inc>        ; Dfinitions des constantes

	__CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_OFF & _LVP_OFF & _BODEN_OFF & _XT_OSC

;	_CP_ON		Code protection ON : impossible de relire
;	_CP_OFF		Code protection OFF
;	_PWRTE_ON	Timer reset sur power on en service
;	_PWRTE_OFF	Timer reset hors-service

;*********************************************************************
;                              ASSIGNATIONS                          *
;*********************************************************************

OPTIONVAL	EQU	0x80	; Valeur registre option
                                ; Rsistance pull-up OFF
;INTERMASK	EQU	H'0090' ; Masque d'interruption

;*********************************************************************
;                             DEFINE                                 *
;*********************************************************************
;DS
#DEFINE DQ		PORTA,0		; Ligne open drain

;Afficheur
#DEFINE RS			PORTA,1		; Selection du registre afficheur
#DEFINE E			PORTA,2		; Enable
#DEFINE	LCD_DATA	PORTB		; Afficheur LCD

;Emetteur
;#DEFINE OUTPUT		PORTC,6		; Sortie Vers module emission TX

;*********************************************************************
;                             MACRO                                  *
;*********************************************************************

BANK0	macro	
	bcf	STATUS,RP0
	endm

BANK1	macro	
	bsf	STATUS,RP0
	endm

Pin_low	macro
	BANK1
	bcf	DQ
	BANK0
	bcf	DQ
	endm

Pin_hz	macro
	BANK1
	bsf	DQ
	BANK0
	endm

VALIDE	macro	
	bsf	E
	nop
	bcf	E
	endm

;*********************************************************************
;                   DECLARATIONS DE VARIABLES                        *
;*********************************************************************

	CBLOCK 0x20   		; dbut de la zone variables
	ds_return : 1		; Zone de 1 byte, valeur de retour du DS
	ds_bit:1
	Out_Byte :1
	
	ds_cmpt:1
	Loop10	: 1		; Boucle compteur
	Loop1000: 1		; Boucle compteur
	Loop100ms :1
	cmpt1:1			; Boucle compteur
	cmpt2:1	

	Temp_Lsb : 1		; zone de 1 byte
	Temp_Msb : 1
	Temp_Msb_1 : 1
	Temp_Lsb_1 : 1
	Temp_Msb_2 : 1
	Temp_Lsb_2 : 1


	cpt_blanc
	Temp_diz : 1		; zone de 1 byte
	Temp_cent : 1
	Temp_unit : 1
	dec		:1
        ENDC			; Fin de la zone                        

;**********************************************************************
;                      DEMARRAGE SUR RESET                            *
;**********************************************************************

	org	0x000 		; Adresse de dpart aprs reset
  	goto	Main		; Adresse 0: initialiser

;*********************************************************************
;                       INITIALISATIONS DU PIC                            *
;*********************************************************************

Init
	
	bcf	STATUS,RP1
	BANK0

	clrf	PORTA		; Sorties portA  0

	BANK1

	movlw	0x01		; PortA,0	en entre,  les autres en sorties		
	movwf	TRISA		
	
	movlw	0x06
	movwf	ADCON1		; entres sorties numriques
	
	clrf	TRISB		; portB en sortie
	clrf	TRISC		; portC ..

	movlw	OPTIONVAL	; charger masque
	movwf	OPTION_REG	; initialiser registre option
	
	BANK0
	
	clrf	PORTB		; sorties portB  0
	clrf	PORTC		; sorties portC  0

			; Effacer RAM
			
	movlw	0x20		; initialisation pointeur
	movwf	FSR		; pointeur d'adressage indirec
Init1
	clrf	INDF		; effacer ram
	incf	FSR,f		; pointer sur suivant
	btfss	FSR,7		; tester si fin zone atteinte (>=7F)
	goto	Init1		; non, boucler

	return

;*********************************************************************
;                      PROGRAMME PRINCIPAL                           *
;*********************************************************************

Main
		call	Init
		call	LCD_Init
Main1
		call	InitDS18B20
	
		call	ReadTemp

		movf	Temp_Lsb,W
		movwf	PORTC

		movf	Temp_Msb,W
		movwf	Temp_Msb_1
		movwf	Temp_Msb_2

		movf	Temp_Lsb,W
		movwf	Temp_Lsb_1
		movwf	Temp_Msb_2

		rrf	Temp_Msb_1,f
		btfsc	STATUS,C
		bsf	PORTA,3
		nop

		rrf	Temp_Msb_1,f
		btfsc	STATUS,C
		bsf	PORTA,4		;attention a cette pin.......
		nop

		rrf	Temp_Msb_1,f
		btfsc	STATUS,C
		bsf	PORTA,5
		nop

		movlw	'T'
		call	LCD_Write_car

		movlw	'='
		call	LCD_Write_car

		call	Affich_Temp
					
		movlw	'('
		call	LCD_Write_car

		movf	Temp_Msb_2,W
		call	LCD_Write_car
		
		movf	Temp_Lsb_2,W
		call	LCD_Write_car

		movlw	')'
		call	LCD_Write_car

		movlw	.10
		call	delay_100ms
		incf	PORTC,f


		goto	Main


;*********************************************************************
;                      Initialisation DS18B20                        *
;*********************************************************************

InitDS18B20
		call	resetPresence
		movf	ds_return,F
		btfsc	STATUS,Z
		return	; resetPresence failed
		
;		movlw	0xCC		; Skip ROM
;		call	WriteTempByte
;		movlw	0x4E		; Write Scratchpad
;		call	WriteTempByte
;		movlw	0x00		; Write TH
;		call	WriteTempByte
;		movlw	0x00		; Write TL
;		call	WriteTempByte
;		movlw	0x7F		; Write config du DS resolution de 12 Bits
;		call	WriteTempByte

		movlw	.1
		movwf	ds_return
		
		return

;*********************************************************************
;                      Reset Presence	                             *
;*********************************************************************

resetPresence
		Pin_hz
		movlw	.0
		movwf	ds_return

		Pin_low
		movlw	.50
		call	delay_10u	; attendre 500 s
		Pin_hz		; Haute impdance
		movlw	.6
		call	delay_10u	; attendre 60 s
		btfsc	DQ
		return

		movlw	.6
		call	delay_10u	; attendre 60 s
;
;		btfsc	DQ
;		return

		movlw	.36
		call	delay_10u	; attendre 360 s
	
		movlw	.1
		movwf	ds_return

		return

;*********************************************************************
;                      ReadTemp                                      *
;*********************************************************************

ReadTemp
		call	resetPresence

		movlw	0xCC	; Skip ROM
		call	WriteTempByte

		movlw	0x44	; temp conversion
		call	WriteTempByte

;Ds_loop_read
		movlw	.255
		call	delay_1ms
;		call	ReadTempBit
;		btfss	ds_bit,0
;		goto	Ds_loop_read

		movlw	.255
		call	delay_1ms
		
		movlw	.255
		call	delay_1ms

		movlw	.255
		call	delay_1ms

		call	resetPresence
;		movf	ds_return,F
;		btfsc	STATUS,Z
;		return	; resetPresence failed

		movlw	0xCC	; Skip ROM
		call	WriteTempByte

		movlw	0xBE	; Read Scratchpad
		call	WriteTempByte
		
		call	ReadTempByte
		movf	ds_return,W
		movwf	Temp_Lsb

		call	ReadTempByte
		movf	ds_return,W
		movwf	Temp_Msb

		call	resetPresence

		return

;*********************************************************************
;                     ReadTempByte                                   *
;*********************************************************************

ReadTempByte
		movlw	.8
		movwf	ds_cmpt
DS_boucle_rot
		call	ReadTempBit
		rrf	ds_bit,F
		rrf	ds_return,F
		decfsz	ds_cmpt,F
		goto	DS_boucle_rot
		
		return

;*********************************************************************
;                      ReadTempBit                                   *
;*********************************************************************

ReadTempBit
		Pin_low
		nop
		nop
		Pin_hz
		nop
		nop
		nop
		nop
		nop
		nop	; 8s en plus
		
		movf	PORTA,W
		movwf	ds_bit

		movlw	.6
		call	delay_10u
		
		return

;*********************************************************************
;                     WriteTempByte                                   *
;*********************************************************************

WriteTempByte
		movwf	Out_Byte
		movlw	.8
		movwf	ds_cmpt
WriteTempByte_1
		rrf	Out_Byte,F
		btfss	STATUS,C
		goto	Write_0
		goto	Write_1
WriteTempByte_2
		decfsz	ds_cmpt,F
		goto	WriteTempByte_1
		return

Write_0
		Pin_low
		movlw	.6
		call	delay_10u
		Pin_hz
		goto	WriteTempByte_2

Write_1
		Pin_low
		nop
		Pin_hz
		movlw	.6
		call	delay_10u
		goto	WriteTempByte_2

; * * * * * * * * * * * * * * * * * * * * ***
; LCD_Init		Initialisation du module LCD*
; * * * * * * * * * * * * * * * * * * * * ***

LCD_Init
	bcf	RS	; On met a 0 RS pour les commandes
	bcf	E

	movlw	.15
	call   delay_1ms  ; tempo 15 ms

	movlw	0x38
	movwf	LCD_DATA
	VALIDE	;	2 lignes 8 bits

	movlw	.5
	call	delay_1ms

	movlw	0x38
	movwf	LCD_DATA
	VALIDE	;	2 lignes 8 bits

	movlw	.10
	call	delay_10u

	movlw	0x38
	movwf	LCD_DATA
	VALIDE	;	2 lignes 8 bits

	movlw	.10
	call	delay_10u

	movlw	0x38
	movwf	LCD_DATA
	VALIDE	;	2 lignes 8 bits

	movlw	.10
	call	delay_10u

	movlw	0x0E
	movwf	LCD_DATA
	VALIDE		;Affichage ON [D=1(Affon), C=1(Cursr visible)

	movlw	.10
	call	delay_10u

	movlw	0x01
	movwf	LCD_DATA
	VALIDE		; Clear display

	movlw	.2
	call   delay_1ms  ; tempo 2 ms

	movlw	0x06
	movwf	LCD_DATA
	VALIDE		; curseur se deplace tout seul

	movlw	.10
	call	delay_10u

	return
	
;******************************************************
;*  LCD_Write    On prend le caractres  partir de W *
;******************************************************

LCD_Write_ASCII
	addlw	'0'
LCD_Write_car
	bsf	RS	; On met a 1 RS pour les caractres
	movwf	LCD_DATA
	VALIDE

	movlw	.10
	call	delay_10u
	
	return

;*********************************************************************
;                      Affich_Temp				                     *
;*********************************************************************

Affich_Temp
	btfsc	Temp_Msb,3
	goto	Temp_neg
	
	movlw	'+'
	call	LCD_Write_car
	
	goto	Temp_pos
	
Temp_neg
	movlw	'-'
	call	LCD_Write_car
		
	comf	Temp_Msb,f		;Complement a 2 des 2 variables
	incf	Temp_Msb,f
	comf	Temp_Lsb,f
	incf	Temp_Lsb,f
		
Temp_pos

	call	Bin_to_BCD
	
	movf	Temp_cent,W
	call	LCD_Write_ASCII
	
	movf	Temp_diz,W
	call	LCD_Write_ASCII
	
	movf	Temp_unit,W
	call	LCD_Write_ASCII

	movlw	'.'
	call	LCD_Write_car

	btfsc	dec,3
	goto	bit1_
	btfsc	dec,2
	goto	bit0_1
	goto	bit0_0
	
bit1_
	btfsc	dec,2
	goto	bit1_1
	goto	bit1_0
		
bit0_0
	movlw	'0'
	call	LCD_Write_car
	
	movlw	'0'
	call	LCD_Write_car

	goto	fin_aff_dec

bit0_1
	movlw	'2'
	call	LCD_Write_car
	
	movlw	'5'
	call	LCD_Write_car

	goto	fin_aff_dec
	
bit1_0
	movlw	'5'
	call	LCD_Write_car
	
	movlw	'0'
	call	LCD_Write_car

	goto	fin_aff_dec
	
bit1_1
	movlw	'7'
	call	LCD_Write_car
	
	movlw	'5'
	call	LCD_Write_car

fin_aff_dec
	movlw	0xDF
	call	LCD_Write_car

	movlw	'C'
	call	LCD_Write_car
	
;	movlw	.25
;	call	Aff_Blanc
	
	return


;*********************************************************************
;                      Aff_Blanc				                     *
;*********************************************************************

Aff_Blanc
	movwf	cpt_blanc
	movlw	' '
boucle_blanc
	call	LCD_Write_car
	decfsz	cpt_blanc,f
	goto	boucle_blanc
	
	return


;*********************************************************************
;                      Bin_to_BCD				                     *
;*********************************************************************

Bin_to_BCD
	clrf	dec
	
	rrf	Temp_Msb,f
	rrf	Temp_Lsb,f
	rrf	dec,f
	
	rrf	Temp_Msb,f
	rrf	Temp_Lsb,f
	rrf	dec,f
	
	rrf	Temp_Msb,f
	rrf	Temp_Lsb,f
	rrf	dec,f
	
	rrf	Temp_Msb,f
	rrf	Temp_Lsb,f
	rrf	dec,f

	swapf	dec,f
	
	movf	Temp_Lsb,W
	
	clrf	Temp_cent
	clrf	Temp_diz
	clrf	Temp_unit
		
centaine
	incf	Temp_cent,f
	
	addlw	-.100		;W-100->W
	btfsc	STATUS,Z
	goto	final
	btfsc	STATUS,C	
	goto	centaine
	
	addlw	.100
	decf	Temp_cent,f
	
dizaine
	incf	Temp_diz,f
	
	addlw	-.10		;W-10->W
	btfsc	STATUS,Z
	goto	final
	btfsc	STATUS,C
	goto	dizaine
	
	addlw	.10
	decf	Temp_diz,f

unite
	incf	Temp_unit,f
	
	addlw	-.1		;W-1->W
	btfsc	STATUS,Z
	goto	final
	btfsc	STATUS,C
	goto	unite
	
	addlw	.1
	decf	Temp_unit,f

final
	return

;*********************************************************************
;                      Boucle d'attente de 10sec*W + 4 s           *
;*********************************************************************

delay_10u
		movwf	Loop10	
delay_10u_1
		NOP	
		NOP
		NOP
		NOP	
		NOP
		NOP
		NOP
		decfsz	Loop10,F
		goto	delay_10u_1

		return

;*********************************************************************
;                      Boucle d'attente de 1msec*W  +4s             *
;*********************************************************************

delay_1ms
		movwf	Loop1000
delay_1ms_1
		clrf	cmpt1
delay
		decfsz	cmpt1,f
		goto	delay
	
		movlw	.76
		movwf	cmpt1
delay2	
		decfsz	cmpt1,f
		goto	delay2

		decfsz	Loop1000,f
		goto	delay_1ms_1
	
		return



;*********************************************************************
;                      Boucle d'attente de 100msec*W  + 4 s             *
;*********************************************************************

delay_100ms
		movwf	Loop100ms

delay_100ms_1

		movlw	.129
		movwf	cmpt2
		clrf	cmpt1
delay_100ms_2
		decfsz	cmpt1,f
		goto	delay_100ms_2
		
		nop
		nop
		nop
		nop
		nop

		decfsz	cmpt2,f
		goto	delay_100ms_2	

		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop		; 20s
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop

		decfsz	Loop100ms,f
		goto	delay_100ms_1
	
		return
	END 			; directive fin de programme
